// drweb-clamd API usage example.
// (C) 2003-2016 Doctor Web. All rights reserved.

#ifndef DRWEB_CLAMD_C_API_COMMON_H
#define DRWEB_CLAMD_C_API_COMMON_H

#include <sys/types.h>

#define MAX_FILES 15

typedef struct parsed_args_t
{
    const char* socket;
    const char* files[MAX_FILES + 1];
    const char* cmd;
} parsed_args_t;

void error(const char* fmt, ...);
int connect_to_clamd(const char* socket_path);
void write_exact(int fd, const void* buffer, size_t size);

void scan(int clamd, const char* file_path, const char* cmd);
void instream_scan(int clamd, const char* file_path);
void fildes_scan(int clamd, const char* file_path);

void parse_args(int argc, const char* argv[], parsed_args_t* args);
void read_response(int fd);
size_t read_until(int sock, char term, char* buf, size_t size);

#endif // DRWEB_CLAMD_C_API_COMMON_H
